function [K,Ff,T]=Create_TKF(E,I,A,LX,LY,MT,Qf)
% The input parameters are E, I, A, LX, LY, and Qf. 
% The outputs are K, Ff, T.  
% Order of input parameters must be identical here and in the main program.

L=sqrt(LX^2+LY^2);
c=LX/L;     % cosine
s=LY/L;     % sine


FAb=Qf(1,1);
FSb=Qf(2,1);
FMb=Qf(3,1);
FAe=Qf(4,1);
FSe=Qf(5,1);
FMe=Qf(6,1);


if MT==0    % rigid connection at both ends

Qf=[FAb;FSb;FMb;FAe;FSe;FMe];

k=E*I/L^3*[
 A*L^2/I   0     0  -A*L^2/I    0     0
       0  12   6*L         0  -12   6*L
       0 6*L 4*L^2         0 -6*L 2*L^2         
-A*L^2/I   0     0   A*L^2/I    0     0
       0 -12  -6*L         0   12  -6*L
       0 6*L 2*L^2         0 -6*L 4*L^2];

else if MT==1   % hinge at beginning
            
Qf=[FAb;FSb-(3/(2*L))*FMb;0;FAe;FSe+(3/(2*L))*FMb;FMe-(1/2)*FMb];  

k=E*I/L^3*[
 A*L^2/I   0     0  -A*L^2/I    0     0
       0   3     0         0   -3   3*L
       0   0     0         0    0     0         
-A*L^2/I   0     0   A*L^2/I    0     0
       0  -3     0         0    3  -3*L
       0 3*L     0         0 -3*L 3*L^2];
      
else if MT==2   % hinge at end
              
Qf=[FAb;FSb-(3/(2*L))*FMe;FMb-(1/2)*FMe;FAe;FSe+(3/(2*L))*FMe;0];

k=E*I/L^3*[
 A*L^2/I   0     0  -A*L^2/I    0     0
       0   3   3*L         0   -3     0
       0 3*L 3*L^2         0 -3*L     0         
-A*L^2/I   0     0   A*L^2/I    0     0
       0  -3  -3*L         0    3     0
       0   0     0         0    0     0];

else if MT==3   % hinged connection at both ends
        
Qf=[FAb;FSb-(1/L)*(FMb+FMe);0;FAe;FSe+(1/L)*(FMb+FMe);0];

k=E*A/L*[
       1   0   0  -1   0   0
       0   0   0   0   0   0
       0   0   0   0   0   0        
      -1   0   0   1   0   0
       0   0   0   0   0   0
       0   0   0   0   0   0];
        
    end
    end
    end
end


Qf


T=[
 c s  0  0 0 0 
-s c  0  0 0 0
 0 0  1  0 0 0
 0 0  0  c s 0
 0 0  0 -s c 0
 0 0  0  0 0 1];   


Ff=T'*Qf;

K=T'*k*T;